#ifndef __PRIVATE_XWBOARDSDK_H
#define __PRIVATE_XWBOARDSDK_H

#ifdef __cplusplus
extern "C" {
#endif 

#include <windows.h>
#include "stdio.h"
#include "ceddk.h"
#include <Winuser.h>
#include <Pkfuncs.h>
#include <memory.h>
#include "Nkintr.h"  
#include <oalintr.h> 
#include "XLLP_GPIO.h"
#include "XLLP_INTC.h"
#include "xllp_Pm_OsSpecific.h"
#include "xllp_serialization.h"
#include "xllp_ost.h"
#include "xllp_rtc.h"
#include "xllp_clkmgr.h"
#include "bvd1bd.h"
#include "halether.h"
#include "bvd1.h"
#include "winpacsdk.h"


#define PRIVATE static
#define PUBLIC  /* */

#define PRIVATE_API static
#define PUBLIC_API  /* */

#define GPIO_BASE	0x40E00000
//#define CLK_BASE	0x41300000

#define PWM_02		0x40B00000
#define PWM_03		0x40C00000
//#define OST_BASE	0x40A00000
	

#define _XW107_	107 
//#define _XW305B_	305  
#define _XW110_	110 

//#define _X200_	200 
#define _X201_	201 
#define _X202_	202 
#define _X203_	203
#define _X205_	205
#define _X206_	206

#define _X300_	300 
#define _X301_	301 
#define _X302_	302 
#define _X303_	303 
#define _X304_	304 
#define _X305_	305 

#define _X306_	306 
//#define _X307_	307 
#define _X308_	308 
#define _X309_	309 
#define _X310_	310 
#define _X314_	314 

#define outp(a,b)	_pac_outp(a, b) 
#define inp(a)		_pac_inp(a) 

typedef volatile struct 
{
    DWORD gplr0;	// Level Reg. Bank 0
    DWORD gplr1;	// Level Reg. Bank 1
    DWORD gplr2;	// Level Reg. Bank 2
    DWORD gpdr0;	// Direction Reg. Bank 0
    DWORD gpdr1;	// Direction Reg. Bank 1
    DWORD gpdr2;	// Direction Reg. Bank 2
    DWORD gpsr0;	// Output Set Reg. Bank 0
    DWORD gpsr1;	// Output Set Reg. Bank 1
    DWORD gpsr2;	// Output Set Reg. Bank 2
    DWORD gpcr0;	// Output Clr Reg. Bank 0
    DWORD gpcr1;	// Output Clr Reg. Bank 1
    DWORD gpcr2;	// Output Clr Reg. Bank 2
    DWORD grer0;	// Ris. Edge Detect Enable Reg. Bank 0
    DWORD grer1;	// Ris. Edge Detect Enable Reg. Bank 1
    DWORD grer2;	// Ris. Edge Detect Enable Reg. Bank 2
    DWORD gfer0;	// Fal. Edge Detect Enable Reg. Bank 0
    DWORD gfer1;	// Fal. Edge Detect Enable Reg. Bank 1
    DWORD gfer2;	// Fal. Edge Detect Enable Reg. Bank 2
    DWORD gedr0;	// Edge Detect Status Reg. Bank 0
    DWORD gedr1;	// Edge Detect Status Reg. Bank 1
    DWORD gedr2;	// Edge Detect Status Reg. Bank 2
    DWORD gafr0_l;	// Alt. Function Select Reg.[  0:15 ]
    DWORD gafr0_u;	// Alt. Function Select Reg.[ 16:31 ]
    DWORD gafr1_l;	// Alt. Function Select Reg.[ 32:47 ]
    DWORD gafr1_u;	// Alt. Function Select Reg.[ 48:63 ]
    DWORD gafr2_l;	// Alt. Function Select Reg.[ 64:79 ]
    DWORD gafr2_u;	// Alt. Function Select Reg.[ 80:95 ]
    DWORD gafr3_l;	// Alt. Function Select Reg.[ 96:111]
    DWORD gafr3_u;	// Alt. Function Select Reg.[112:120]
    DWORD res1[35];
    DWORD gplr3;	// Level Detect Reg. Bank 3
    DWORD res2[2];
    DWORD gpdr3;	// Data Direction Reg. Bank 3
    DWORD res3[2];
    DWORD gpsr3;	// Pin Output Set Reg. Bank 3
    DWORD res4[2];
    DWORD gpcr3;	// Pin Output Clr Reg. Bank 3
    DWORD res5[2];
    DWORD grer3;	// Ris. Edge Detect Enable Reg. Bank 3
    DWORD res6[2];
    DWORD gfer3;	// Fal. Edge Detect Enable Reg. Bank 3
    DWORD res7[2];
    DWORD gedr3;	// Edge Detect Status Reg. Bank 3

} GPIOREG;


typedef volatile struct
{
    DWORD    cccr;         	// Core Clock Configuration register
    DWORD    cken;         	// Clock Enable register
    DWORD    oscc;         	// Oscillator Configuration register
    DWORD    ccsr;         	// Core Clock Status register
 } CLKMGR_T;  

typedef volatile struct
{
    DWORD    pwmcr0;
    DWORD    pwmdcr0;
    DWORD    pwmpcr0;
    DWORD    reserved;
    DWORD    pwmcr2;
    DWORD    pwmdcr2;
    DWORD    pwmpcr2;
}PWM_REGS_T;

typedef struct
{
    DWORD    osmr0;         	//OS timer match register 0
    DWORD    osmr1;         	//OS timer match register 1
    DWORD    osmr2;         	//OS timer match register 2
    DWORD    osmr3;          	//OS timer match register 3
    DWORD    oscr0;            //OS timer counter register 0(compatible)
    DWORD    ossr;             //OS timer status register
    DWORD    ower;          	//OS timer watchdog enable register
    DWORD    oier;           	//OS timer interrupt enable register
    DWORD    osnr;           	//OS timer snapshot register
    DWORD    reserved1[7];
    DWORD    oscr4;		//OS timer counter register 4
    DWORD    oscr5;		//OS timer counter register  5
    DWORD    oscr6;		//OS timer counter register  6
    DWORD    oscr7;		//OS timer counter register  7
    DWORD    oscr8;		//OS timer counter register  8
    DWORD    oscr9;		//OS timer counter register  9
    DWORD    oscr10;		//OS timer counter register  10
    DWORD    oscr11;		//OS timer counter register  11
    DWORD    reserved2[8];
    DWORD    osmr4;		//OS timer match register 4
    DWORD    osmr5;		//OS timer match register 5
    DWORD    osmr6;		//OS timer match register 6
    DWORD    osmr7;		//OS timer match register 7
    DWORD    osmr8;		//OS timer match register 8
    DWORD    osmr9;		//OS timer match register 9
    DWORD    osmr10;		//OS timer match register 10
    DWORD    osmr11;		//OS timer match register 11
    DWORD    reserved3[8];
    DWORD    omcr4;		//OS timer match control register 4
    DWORD    omcr5;		//OS timer match control register 5
    DWORD    omcr6;		//OS timer match control register 6
    DWORD    omcr7;		//OS timer match control register 7
    DWORD    omcr8;		//OS timer match control register 8
    DWORD    omcr9;		//OS timer match control register 9
    DWORD    omcr10;		//OS timer match control register 10
    DWORD    omcr11;		//OS timer match control register 11
} OST_T;

typedef volatile struct
{
    int		iDITotalchannel;
    int		iDOTotalchannel;
    int		iAITotalchannel;
    int		iAOTotalchannel;
    int		iCounterTotalchannel;
	int		iSerialTotalchannel;
    int		itype; //1: DIO , 2:AIO (some with DIO)  5: COM
	char    Description[100];
}Type_Structure;

#ifdef __cplusplus
}
#endif 


#endif