﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using XWBoardNet;
using System.Runtime.InteropServices;
using System.Threading;

namespace XW304_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        public void reverse(ref uint dwDI)
        {
            if (checkBox4.Checked)
            {
                dwDI ^= 0xF;

            }
        }
        [DllImport("XW304.dll", EntryPoint = "XW304_ReadAi")]
        public extern static bool XW304_ReadAi(int iChannel, int AI_TYPE, ref float fvalue);
        [DllImport("XW304.dll", EntryPoint = "XW304_Init")]
        public extern static void XW304_Init();
        [DllImport("XW304.dll", EntryPoint = "XW304_AnalogOut")]
        public extern static void XW304_AnalogOut(float fValue);

        [DllImport("XW304.dll", EntryPoint = "XW304_SetDelay")]
        public extern static void XW304_SetDelay(int Delayms);
        
        private void btnWriteDO0x55_Click(object sender, EventArgs e)
        {
            uint dwDO, dwDI;
            dwDI = dwDO = 0;
            try
            {
                if (Convert.ToUInt32(txtBDoValue.Text, 16) < (0xF + 1))
                    XWBoard.XWB_WriteDO(8, Convert.ToUInt32(txtBDoValue.Text, 16));// XW107 8DI 8DO
                else
                {
                    MessageBox.Show("The XW304 only have 4 DO.");
                    txtBDoValue.Text = "0xF";
                }
            }
            catch (Exception ee)
            {
                MessageBox.Show("Error Value");
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);

            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox0_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox0.Checked)
            {
                XWBoard.XWB_WriteDOBit(4, 0, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(4, 0, 0);
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox1_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox1.Checked)
            {
                XWBoard.XWB_WriteDOBit(4, 1, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(4, 1, 0);
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox2_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox2.Checked)
            {
                XWBoard.XWB_WriteDOBit(4, 2, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(4, 2, 0);
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox3_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox3.Checked)
            {
                XWBoard.XWB_WriteDOBit(4, 3, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(4, 3, 0);
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        int ai_type = 0;//0 Ai read range -5~+5, 1 Ai read range 0~+5
        private void button2_Click(object sender, EventArgs e)
        {
            int iChannel_Readed;
            float fAIValue=0;
            XW304_SetDelay(125);//If the value sets more big, the Ai read speed more slow, but the Ai read value more accurate

            iChannel_Readed = comboBoxAiCh.SelectedIndex;

            XW304_ReadAi(iChannel_Readed, ai_type, ref fAIValue);
            txbAiValue.Text = fAIValue.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBoxAiCh.SelectedIndex = 0;
            XW304_Init();
            XW304_AnalogOut(0.0f);
            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            float fAoValue = 0;

            fAoValue = (float)double.Parse(tBxAoValue.Text);
            XW304_AnalogOut(fAoValue);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            uint dwDI=0;
            XWBoard.XWB_ReadDI(4, ref dwDI);
            reverse(ref dwDI);
            textBox2.Text = "DI Readback=" + (dwDI & 0xf).ToString("X");
        }



    }
}