﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using XWBoardNet;

namespace XW310C_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("XW310C.dll", EntryPoint = "XW310C_Init")]
        public extern static void XW310C_Init();
        [DllImport("XW310C.dll", EntryPoint = "XW310C_AnalogOut")]
        public extern static void XW310C_AnalogOut(int iChannel, float fValue);

        [DllImport("XW310C.dll", EntryPoint = "XW310C_ReadAi")]
        public static extern bool XW310C_ReadAi(int iChannel, ref float fvalue);

        [DllImport("XW310C.dll", EntryPoint = "XW310C_GetAnanlogInType")]
        public extern static bool XW310C_GetAnanlogInType();

        [DllImport("XW310C.dll", EntryPoint = "XW310C_SetDelay")]
        public extern static void XW310C_SetDelay(int Delayms);

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBoxAiCh.SelectedIndex = 0;
            comboBoxAoCh.SelectedIndex = 0;
            
            XW310C_Init();
            XW310C_AnalogOut(0, 0.0f);
            XW310C_AnalogOut(1, 0.0f);
            if (XW310C_GetAnanlogInType())/*SINGLE_ENDED    0, DIFFERENTIAL    1*/
                label8.Text = "Ai type is DIFFERENTIAL.";
            else
                label8.Text = "Ai type is SINGLE_ENDED.";

        }

        private void btnWriteDO0x55_Click(object sender, EventArgs e)
        {
            uint dwDO, dwDI;
            dwDI = dwDO = 0;
            try
            {
                if (Convert.ToUInt32(txtBDoValue.Text, 16) < (0x7 + 1))
                    XWBoard.XWB_WriteDO(3, Convert.ToUInt32(txtBDoValue.Text, 16));// XW107 8DI 8DO
                else
                {
                    MessageBox.Show("The XW310C only have 3 DO.");
                    txtBDoValue.Text = "0x7";
                }
            }
            catch (Exception ee)
            {
                MessageBox.Show("Error Value");
            }
            XWBoard.XWB_ReadDO(3, ref dwDO);

            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox0_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox0.Checked)
            {
                XWBoard.XWB_WriteDOBit(3, 0, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(3, 0, 0);
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox1_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox1.Checked)
            {
                XWBoard.XWB_WriteDOBit(3, 1, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(3, 1, 0);
            }
            XWBoard.XWB_ReadDO(4, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }

        private void checkBox2_CheckStateChanged(object sender, EventArgs e)
        {
            uint dwDO;
            uint dwDI;
            dwDI = dwDO = 0;
            if (checkBox2.Checked)
            {
                XWBoard.XWB_WriteDOBit(3, 2, 1);
            }
            else
            {
                XWBoard.XWB_WriteDOBit(3, 2, 0);
            }
            XWBoard.XWB_ReadDO(3, ref dwDO);
            textBox1.Text = "DO Readback=" + dwDO.ToString("X");
        }
        public void reverse(ref uint dwDI)
        {
            if (checkBox4.Checked)
            {
                dwDI ^= 0x7;

            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            uint dwDI = 0;
            XWBoard.XWB_ReadDI(3, ref dwDI);
            reverse(ref dwDI);
            textBox2.Text = "DI Readback=" + (dwDI & 0x7).ToString("X");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            int iChannel_Readed;
             float fAIValue=0;
            XW310C_SetDelay(125);//If the value sets more big, the Ai read speed more slow, but the Ai read value more accurate

            iChannel_Readed = comboBoxAiCh.SelectedIndex;
            if (iChannel_Readed > 3 && XW310C_GetAnanlogInType())
            {
                comboBoxAiCh.SelectedIndex = 3;
                iChannel_Readed = 3;
            }
            XW310C_ReadAi(iChannel_Readed, ref fAIValue);
            txbAiValue.Text = fAIValue.ToString();

        }

        private void button3_Click(object sender, EventArgs e)
        {
            float fAoValue = 0;
            int iChannel_Readed;

            fAoValue = (float)double.Parse(tBxAoValue.Text);
            iChannel_Readed = comboBoxAoCh.SelectedIndex;
            XW310C_AnalogOut(iChannel_Readed, fAoValue);
        }


    }
}